#pragma once

#include "rendertarget.hh"
#include "shaders.hh"


struct T_CombinePass
{
	T_CombinePass( ) = delete;
	T_CombinePass( T_CombinePass const& ) = delete;
	T_CombinePass( T_CombinePass&& ) = delete;

	T_CombinePass( T_Texture& image ,
			T_Texture& bloom );

	void render( );
	void makeUI( );

	T_Texture& output( )
		{ return txOutput_; }

    private:
	T_Texture& txImage_;
	T_Texture& txBloom_;

	T_Texture txOutput_;
	T_Rendertarget rtOutput_;

	T_ShaderPipeline program_;

	float bloomStrength_;
	float bloomAttenuation_;

	float vignette_[ 6 ];

	float cgLift_[ 3 ];
	float cgGain_[ 3 ];
	float cgGamma_[ 3 ];
};

